SD-WAN Configuration Groups

Endpoint Description
https://{gateway_url}/dataservice/v1/config-group List Configuration Groups
https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/associate List Devices in Configuration Group
https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/variables Get Variables for Configuration Group
https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/variables Set Variables for Configuration Group
https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/deploy Deploy a Configuration Group

For information about generating your SD-WAN Manager API Gateway URL and SD-WAN Manager Cross-Site Request Forgery (CSRF) access token, see SASE Authorization.

To get the identifiers of the Configuration Groups in the organization, see List Configuration Groups.

List Configuration Groups

List the Configuration Groups in the organization.

GET https://{gateway_url}/dataservice/v1/config-group

Prerequisites

  • gateway_url: The URL of the SD-WAN Manager API gateway.
  • apikey: The API key for the SD-WAN Manager organization.
  • xsrf_token: The SD-WAN Manager CSRF access token.

Request

curl --request GET \
  --url https://{gateway_url}/dataservice/v1/config-group \
  --header 'Authorization: Bearer {apikey}' \
  --header 'Content-Type: application/json' \
  --header 'X-xsrf-token: {xsrf_token}'

Response

[
  {
    "id": "d9e1dc83-4770-4b61-9da0-d5e02b8be615",
    "name": "CG_Darkhill",
    "description": "",
    "source": "retail_workflow",
    "solution": "sdwan",
    "lastUpdatedBy": "user@cisco.com",
    "lastUpdatedOn": 1773935225113,
    "createdBy": "user@cisco.com",
    "createdOn": 1773926704678,
    "profiles": [
      {
        "id": "531ba289-d220-44e7-8a21-8642f0d711a1",
        "name": "CG_Darkhill_New_base_Baseline_CG1_LAN",
        "solution": "sdwan",
        "type": "service",
        "description": null,
        "lastUpdatedBy": "user@cisco.com",
        "lastUpdatedOn": 1773935225113,
        "createdBy": "user@cisco.com",
        "createdOn": 1773926706043,
        "profileParcelCount": 10,
        "origin": null
      },
      {
        "id": "33c4a947-cfed-4110-aafb-c9e8d0428ed4",
        "name": "CG_Darkhill_New_base_Baseline_CG1_WAN",
        "solution": "sdwan",
        "type": "transport",
        "description": null,
        "lastUpdatedBy": "user@cisco.com",
        "lastUpdatedOn": 1773932822326,
        "createdBy": "user@cisco.com",
        "createdOn": 1773926705709,
        "profileParcelCount": 7,
        "origin": null
      },
      {
        "id": "567444d9-9b13-4459-9a83-dbab1d426adf",
        "name": "CG_Darkhill_New_base_Baseline_CG1_Basic",
        "solution": "sdwan",
        "type": "system",
        "description": null,
        "lastUpdatedBy": "user@cisco.com",
        "lastUpdatedOn": 1773935405501,
        "createdBy": "user@cisco.com",
        "createdOn": 1773926704804,
        "profileParcelCount": 24,
        "origin": null
      }
    ],
    "version": 10,
    "state": null,
    "devices": [],
    "numberOfDevices": 1,
    "numberOfDevicesUpToDate": 1,
    "origin": "user",
    "copyInfo": {
      "groupId": "00135d57-18bf-44f0-bba5-7a26ca4f31ea"
    },
    "originInfo": null,
    "topology": null,
    "fullConfigCli": false,
    "iosConfigCli": false,
    "versionIncrementReason": null
  },
]

List Devices in Configuration Group

List the devices that are associated with the Configuration Group.

GET https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/associate

Prerequisites

  • gateway_url: The URL of the SD-WAN Manager API gateway.
  • apikey: The API key for the SD-WAN Manager organization.
  • xsrf_token: The SD-WAN Manager CSRF access token.
  • configGroupId: The identifier of the Configuration Group.

Request

curl --request GET \
  --url https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/associate \
  --header 'Authorization: Bearer {apikey}' \
  --header 'Content-type: application/json' \
  --header 'X-xsrf-token: {xsrf_token}'

Response

{
  "devices": [
    {
      "id": "C1111-8PWE-FCZ2504R2BA",
      "site-name": "Darkhil",
      "host-name": "site-home",
      "site-id": "4",
      "deviceModel": "vedge-C1111-8PW",
      "tags": [],
      "device-lock": "Yes",
      "addedByRule": false,
      "configStatusMessage": "In Sync",
      "deviceIP": "10.0.0.6",
      "configGroupLastUpdatedOn": "1774348630463",
      "unsupportedFeatures": [],
      "hierarchyNamePath": "Global/Darkhil",
      "hierarchyTypePath": "GLOBAL/SITE",
      "groupTopologyLabel": "",
      "configGroupUpToDate": "True",
      "isDeployable": true,
      "licenseStatus": "Unlicensed"
    }
  ]
} 

Get Variables for Configuration Group

Get the settings (name and value) for the devices in the Configuration Group.

GET https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/variables

Prerequisites

  • gateway_url: The URL of the SD-WAN Manager API gateway.
  • apikey: The API key for the SD-WAN Manager organization.
  • xsrf_token: The SD-WAN Manager CSRF access token.
  • configGroupId: The identifier of the Configuration Group.

Request

curl --request GET \
  --url https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/variables \
  --header 'Authorization: Bearer {apikey}' \
  --header 'Content-Type: application/json' \
  --header 'X-xsrf-token: {xsrf_token}'

Response

{
  "family": "sdwan",
  "devices": [
    {
      "device-id": "C1111-8PWE-FCZ2504R2BA",
      "variables": [
        {
          "name": "system_ip",
          "value": "10.0.0.6"
        },
        {
          "name": "host_name",
          "value": "device-one"
        },
        {
          "name": "site_id",
          "value": 4
        },
        {
          "name": "ipv6_strict_control",
          "value": false
        },
        {
          "name": "pseudo_commit_timer",
          "value": 300
        },
        {
          "name": "ServiceSide_IP",
          "value": "192.168.16.1"
        },
        {
          "name": "ServiceSide_SubnetMask",
          "value": "255.255.255.0"
        },
        {
          "name": "DHCP_Network_address",
          "value": "192.168.16.0"
        },
        {
          "name": "dhcp-server_exclude",
          "value": [
            "192.168.16.1"
          ]
        },
        {
          "name": "DHCP_GW_Addr",
          "value": "192.168.16.1"
        }
      ]
    }
  ],
  "groups": [
    {
      "name": "CG_Darkhill",
      "group-variables": []
    }
  ]
}

Set Variables for Configuration Group

Set the variables for the devices in the Configuration Group.

PUT https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/variables

Prerequisites

Collect the SD-WAN API gateway URL, path parameters, and Cross-Site Request Forgery access token.

  • gateway_url: The URL of the SD-WAN Manager API gateway.
  • apikey: The API key for the SD-WAN Manager organization.
  • xsrf_token: The SD-WAN Manager CSRF access token.
  • configGroupId: The identifier of the Configuration Group.

Required Fields in Request Body

Collect the identifiers (UUIDs) of the devices for the Configuration Group.

  1. Get the devices in the Configuration Groups. For more information, see List Devices in Configuration Group .
  2. In the response, navigate to the list of devices, search for the id of the device, and then copy the value of the id field.
  3. Set the value of id for the device in the request body of the SD-WAN Manager API.
  4. To get the settings on a device, see Get Variables for Configuration Group.

Request

curl --request PUT \
  --url https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/variables \
  --header 'Authorization: Bearer {apikey}' \
  --header 'Content-type: application/json' \
  --header 'X-xsrf-token: {xsrf_token}' \
  --data '{
  "solution": "sdwan",
  "devices": [
    {
      "device-id": "C1111-8PWE-FCZ2504R2BA",
      "variables": [
        {
          "name": "system_ip",
          "value": "10.0.0.6"
        },
        {
          "name": "host_name",
          "value": "device-one"
        },
        {
          "name": "site_id",
          "value": 4
        },
        {
          "name": "ipv6_strict_control",
          "value": false
        },
        {
          "name": "pseudo_commit_timer",
          "value": 300
        },
        {
          "name": "ServiceSide_IP",
          "value": "192.168.16.1"
        },
        {
          "name": "ServiceSide_SubnetMask",
          "value": "255.255.255.0"
        },
        {
          "name": "DHCP_Network_address",
          "value": "192.168.16.0"
        },
        {
          "name": "dhcp-server_exclude",
          "value": [
            "192.168.16.1"
          ]
        },
        {
          "name": "DHCP_GW_Addr",
          "value": "192.168.16.1"
        }
      ]
    }
  ]
}'

Response

[
  "C1111-8PWE-FCZ2504R2BA"
]

Deploy a Configuration Group

Activate the Configuration Group for the devices in the SASE Management organization.

POST https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/deploy

Prerequisites

  • gateway_url: The URL of the SD-WAN Manager API gateway.
  • apikey: The API key for the SD-WAN Manager organization.
  • xsrf_token: The SD-WAN Manager CSRF access token.
  • configGroupId: The identifier of the Configuration Group.

Required Fields in Request Body

Collect the identifiers (UUIDs) of the devices for the Configuration Group.

  1. Get the devices in the Configuration Groups. For more information, see List Devices in Configuration Group .
  2. In the response, navigate to devices, search for the id of the device, and then copy the value of id.
  3. Set the value of id for the device in the list of devices.

Request

curl --request POST \
  --url https://{gateway_url}/dataservice/v1/config-group/{configGroupId}/device/deploy \
  --header 'Authorization: Bearer {apikey}' \
  --header 'Content-Type: application/json' \
  --header 'X-xsrf-Token: {xsrf_token}' \
  --data '{
    "devices": [
        {
            "id": "C1111-8PWE-FCZ2504R2BA"
        }
    ]
}'

Response

The parentTaskId is the identifier of the deployment task that runs in the SD-WAN Manager.

{
  "parentTaskId": "deploy_config_group-c6202caf-db8c-43aa-8608-cc7d390b6ed5" 
}